---
import { Site, OpenGraph } from '../config';
export interface Props {
	frontmatter: any;
	site: any;
	canonicalURL: URL | string;
}

const canonicalURL = new URL(Astro.url.pathname, Astro.site);
const { frontmatter = {} } = Astro.props;
const formattedContentTitle = frontmatter.title
	? `${frontmatter.title} - ${Site.title}`
	: Site.title;
const imageSrc = frontmatter?.image?.src ?? OpenGraph.image.src;
const canonicalImageSrc = new URL(imageSrc, Astro.site);
const imageAlt = frontmatter?.image?.alt ?? OpenGraph.image.alt;
---

<!-- Page Metadata -->
<link rel="canonical" href={canonicalURL} />

<!-- OpenGraph Tags -->
<meta property="og:title" content={formattedContentTitle} />
<meta property="og:type" content="article" />
<meta property="og:url" content={canonicalURL} />
<meta property="og:locale" content={frontmatter.ogLocale ?? Site.defaultLanguage} />
<meta property="og:image" content={canonicalImageSrc} />
<meta property="og:image:alt" content={imageAlt} />
<meta
	name="description"
	property="og:description"
	content={frontmatter.description ? frontmatter.description : Site.description}
/>
<meta property="og:site_name" content={Site.title} />

<!-- Twitter Tags -->
<meta name="twitter:card" content="summary_large_image" />
<meta name="twitter:site" content={OpenGraph.twitter} />
<meta name="twitter:title" content={formattedContentTitle} />
<meta
	name="twitter:description"
	content={frontmatter.description ? frontmatter.description : Site.description}
/>
<meta name="twitter:image" content={canonicalImageSrc} />
<meta name="twitter:image:alt" content={imageAlt} />

<!--
  TODO: Add json+ld data, maybe https://schema.org/APIReference makes sense?
  Docs: https://developers.google.com/search/docs/advanced/structured-data/intro-structured-data
  https://www.npmjs.com/package/schema-dts seems like a great resource for implementing this.
  Even better, there's a React component that integrates with `schema-dts`: https://github.com/google/react-schemaorg
-->
